<html>
<head>
<meta charset ="utf-8">
<script src="https://d3js.org/d3.v5.min.js"></script>
<style>
#year{
    font-weight: bold;
}
#id1{
    font-weight: bold;
}
#id2{
    font-weight: bold;
}
#id3{
    font-weight: bold;
}
#id4{
    font-weight: bold;
}
#id5{
    font-weight: bold;
}

#chart{
    background-color: lightgoldenrodyellow;
}
body {
	margin: auto;
	width: 650px;
	font: 12px arial;
}

</style>
<link rel="stylesheet" href="css/style(stacked).css">
</head>
<body>
    <style>
		.dropbtn {
		  background-color:#1b262c;
		  color: white;
		  padding: 0px;
		  font-size: 17px;
		  border: none;
		}
		
		.dropdown {
		  position: relative;
		  display: inline-block;
      right: 0px;
      white-space: nowrap;
		}
		
		.dropdown-content {
		  display: none;
		  position: absolute;
		  background-color: #1b262c;
		  min-width: 160px;
		  box-shadow:#1b262c;
		  z-index: 1;
      top: 0px;
      right:-160px;
      float:right;
      font-family: cursive;
      font-size:20px;
		}
		
		.dropdown-content a {
		  color: white;
		  padding: 12px 16px;
		  text-decoration: none;
		  display: block;
    }
    
    .nav-menu.dropdown.dropdown-content.bar-pie{
      display: none;
		  position: absolute;
		  background-color: #1b262c;
		  min-width: 160px;
		  box-shadow:#1b262c;
		  z-index: 1;
      top: 0px;
      right:-160px;
      float:right;
      font-family: cursive;
      font-size:20px;
      color: white;
		  padding: 12px 16px;
		  text-decoration: none;
		  display: block;
    }

    
		
		.dropdown-content a:hover {background-color:#0A79DF;}
		
		.dropdown:hover .dropdown-content {display: block;}
		
		.dropdown:hover .dropbtn {background-color:#0A79DF;color: black;}
		</style>
		
		<div class="hamburger-icon">
			<i class="fas fa-bars open-icon"></i>
		  </div>
		  <div class="navigation-bar">
			<div class="icon-box">
			  <i class="fas fa-times close-icon"></i>
			</div>
			<div class="nav-title">
			  <h3>Dashboard</h3>
			</div>
			<div class="nav-menu">
			  <a href="index.html" class="nav-link">Home</a>
			  <div class="dropdown">
				<a class="nav-link">District-Wise Data</a>
				<div class="dropdown-content">
				  <a href="adilabad.html">Adilabad</a>
				  <a href="karimnagar.html">Karimnagar</a>
				  <a href="khammam.html">Khammam</a>
				  <a href="mahabubnagar.html">Mahbubnagar</a>
				  <a href="nalgonda.html">Nalgonda</a>
				  <a href="hyd.html">Hyderabad</a>
				  <a href="rangareddy.html">Rangareddy</a>
				  <a href="#">Nizamabad</a>
				  <a href="warangal.html">Warangal</a>
				</div>
				</div>
				<div class="dropdown">
				  <a class="nav-link">STATE WISE DATA</a>
				  <div class="dropdown-content">
					<a href="telangana.html">BAR CHART</a>
					<a href="telangana-pie.html">PIE CHART</a>
				  </div>
				  </div>
			  <a href="schools.html" class="nav-link"> Schools Data</a>
			</div>
		  </div>
		<br><br>
<div style="text-align: center;">
<h1>Welcome to literacy rate in Telangana</h1> 
<br><br>
<div id="my_dataviz">
<svg id="chart" width="850" height="400">
	<rect width="14" height="14" style="fill:red;stroke:black;stroke-width:1px" x="784" y="363.5"></rect>
	<rect width="14" height="14" style="fill:lightblue;stroke:black;stroke-width:1px" x="673" y="363.5"></rect>
	<rect width="14" height="14" style="fill:steelblue;stroke:black;stroke-width:1px" x="575" y="363.5"></rect>
</svg>
</div>

<label id="id1">Select City:</label> 
<select id="year"></select>

<br><br>
<label id="id2">High to Low</label> 
<input type="checkbox" id="sort">	
<script>
    d3.csv("data/state.csv").then(d => chart(d))

function chart(csv) {

	var keys = csv.columns.slice(2);

	var year   = [...new Set(csv.map(d => d.Year))]
	var states = [...new Set(csv.map(d => d.State))]

	var options = d3.select("#year").selectAll("option")
		.data(year)
	.enter().append("option")
		.text(d => d)

	var svg = d3.select("#chart"),
		margin = {top: 35, left: 60, bottom: 20, right: -5},
		width = +svg.attr("width") - margin.left - margin.right,
        height = +svg.attr("height") - margin.top - margin.bottom;    

	var x = d3.scaleBand()
		.range([margin.left, width - margin.right])
		.padding(0.2)

	var y = d3.scaleLinear()
		.rangeRound([height - margin.bottom, margin.top])

	var xAxis = svg.append("g")
		.attr("transform", `translate(0,${height - margin.bottom})`)
        .attr("class", "x-axis")
        .style("font-size","1em")

	var yAxis = svg.append("g")
		.attr("transform", `translate(${margin.left},0)`)
        .attr("class", "y-axis")
        .style("font-size","1em")
        .style("font-weight","bold");

	var z = d3.scaleOrdinal()
		.range(["steelblue", "lightblue", "red"])
		.domain(keys);

	update(d3.select("#year").property("value"), 0)

	function update(input, speed) {

		var data = csv.filter(f => f.Year == input)

		data.forEach(function(d) {
			d.total = d3.sum(keys, k => +d[k])
			return d
		})

		y.domain([0, d3.max(data, d => d3.sum(keys, k => +d[k]))]).nice();

		svg.selectAll(".y-axis").transition().duration(speed)
			.call(d3.axisLeft(y).ticks(null, "s"))

		data.sort(d3.select("#sort").property("checked")
			? (a, b) => b.total - a.total
			: (a, b) => states.indexOf(a.State) - states.indexOf(b.State))

		x.domain(data.map(d => d.State));

		svg.selectAll(".x-axis").transition().duration(speed)
			.call(d3.axisBottom(x).tickSizeOuter(0))

		var group = svg.selectAll("g.layer")
			.data(d3.stack().keys(keys)(data), d => d.key)

		group.exit().remove()

		group.enter().append("g")
			.classed("layer", true)
			.attr("fill", d => z(d.key));

		var bars = svg.selectAll("g.layer").selectAll("rect")
            .data(d => d, e => e.data.State)

        bars.exit().remove()
        

		bars.enter().append("rect")
			.attr("width", x.bandwidth())
			.merge(bars)
		    .transition().duration(speed)
			.attr("x", d => x(d.data.State))
			.attr("y", d => y(d[1]))
            .attr("height", d => y(d[0]) - y(d[1]))
          
		var text = svg.selectAll(".text")
			.data(data, d => d.State);

		text.exit().remove()

		text.enter()
		    .append("text")
			.attr("class", "text")
			.attr("text-anchor", "middle")
			.merge(text)
		    .transition()
			.duration(speed)
			.attr("x", d => x(d.State) + x.bandwidth() / 2)
			.attr("y", d => y(d.total) - 5)
			.text(d => d.total)
			.style("font-size","1em")
			.style("font-weight","bold");
        
		text.enter()
		    .append("text")
		    .attr("x", width/2 )
            .attr("y", 370 )
            .attr("class","xaxis")
            .style("text-anchor", "middle")
            .text("Mandal")
            .style("font-size","1em")
			.style("font-weight","bold");
			
		text.enter()
		    .append("text")
		    .attr("transform", "rotate(-90)")
            .attr("class","yaxis")
            .attr("y", 20)
            .attr("x",0 - (height / 2))
            .style("text-anchor", "middle")
            .text("Illiterates")
            .style("font-size","1em")
			.style("font-weight","bold");
			
		text.enter()
		    .append("text")
            .attr("class","male")
            .attr("y", 375)
            .attr("x",550)
            .style("text-anchor", "middle")
            .text("Males -")
			.style("font-size","1em")
			
		text.enter()
		    .append("text")
            .attr("class","female")
            .attr("y", 375)
            .attr("x",640)
            .style("text-anchor", "middle")
            .text("Females -")
            .style("font-size","1em")
			
			
		text.enter()
		    .append("text")
            .attr("class","trans")
            .attr("y", 375)
            .attr("x",740)
            .style("text-anchor", "middle")
            .text("Transgender -")
            .style("font-size","1em")
			
    }

	var select = d3.select("#year")
		.on("change", function() {
			update(this.value, 750)
		})

	var checkbox = d3.select("#sort")
		.on("click", function() {
			update(select.property("value"), 750)
		})
}

</script>
</body>
</html> 